# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ConnectivityAlertsArgs', 'ConnectivityAlerts']

@pulumi.input_type
class ConnectivityAlertsArgs:
    def __init__(__self__, *,
                 connectivity_alerts: pulumi.Input[bool],
                 process_group_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a ConnectivityAlerts resource.
        :param pulumi.Input[bool] connectivity_alerts: TCP connectivity problems
        :param pulumi.Input[str] process_group_id: The scope of this settings
        """
        pulumi.set(__self__, "connectivity_alerts", connectivity_alerts)
        pulumi.set(__self__, "process_group_id", process_group_id)

    @property
    @pulumi.getter(name="connectivityAlerts")
    def connectivity_alerts(self) -> pulumi.Input[bool]:
        """
        TCP connectivity problems
        """
        return pulumi.get(self, "connectivity_alerts")

    @connectivity_alerts.setter
    def connectivity_alerts(self, value: pulumi.Input[bool]):
        pulumi.set(self, "connectivity_alerts", value)

    @property
    @pulumi.getter(name="processGroupId")
    def process_group_id(self) -> pulumi.Input[str]:
        """
        The scope of this settings
        """
        return pulumi.get(self, "process_group_id")

    @process_group_id.setter
    def process_group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "process_group_id", value)


@pulumi.input_type
class _ConnectivityAlertsState:
    def __init__(__self__, *,
                 connectivity_alerts: Optional[pulumi.Input[bool]] = None,
                 process_group_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ConnectivityAlerts resources.
        :param pulumi.Input[bool] connectivity_alerts: TCP connectivity problems
        :param pulumi.Input[str] process_group_id: The scope of this settings
        """
        if connectivity_alerts is not None:
            pulumi.set(__self__, "connectivity_alerts", connectivity_alerts)
        if process_group_id is not None:
            pulumi.set(__self__, "process_group_id", process_group_id)

    @property
    @pulumi.getter(name="connectivityAlerts")
    def connectivity_alerts(self) -> Optional[pulumi.Input[bool]]:
        """
        TCP connectivity problems
        """
        return pulumi.get(self, "connectivity_alerts")

    @connectivity_alerts.setter
    def connectivity_alerts(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "connectivity_alerts", value)

    @property
    @pulumi.getter(name="processGroupId")
    def process_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings
        """
        return pulumi.get(self, "process_group_id")

    @process_group_id.setter
    def process_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "process_group_id", value)


class ConnectivityAlerts(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connectivity_alerts: Optional[pulumi.Input[bool]] = None,
                 process_group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a ConnectivityAlerts resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] connectivity_alerts: TCP connectivity problems
        :param pulumi.Input[str] process_group_id: The scope of this settings
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConnectivityAlertsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a ConnectivityAlerts resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ConnectivityAlertsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConnectivityAlertsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connectivity_alerts: Optional[pulumi.Input[bool]] = None,
                 process_group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConnectivityAlertsArgs.__new__(ConnectivityAlertsArgs)

            if connectivity_alerts is None and not opts.urn:
                raise TypeError("Missing required property 'connectivity_alerts'")
            __props__.__dict__["connectivity_alerts"] = connectivity_alerts
            if process_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'process_group_id'")
            __props__.__dict__["process_group_id"] = process_group_id
        super(ConnectivityAlerts, __self__).__init__(
            'dynatrace:index/connectivityAlerts:ConnectivityAlerts',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            connectivity_alerts: Optional[pulumi.Input[bool]] = None,
            process_group_id: Optional[pulumi.Input[str]] = None) -> 'ConnectivityAlerts':
        """
        Get an existing ConnectivityAlerts resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] connectivity_alerts: TCP connectivity problems
        :param pulumi.Input[str] process_group_id: The scope of this settings
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ConnectivityAlertsState.__new__(_ConnectivityAlertsState)

        __props__.__dict__["connectivity_alerts"] = connectivity_alerts
        __props__.__dict__["process_group_id"] = process_group_id
        return ConnectivityAlerts(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="connectivityAlerts")
    def connectivity_alerts(self) -> pulumi.Output[bool]:
        """
        TCP connectivity problems
        """
        return pulumi.get(self, "connectivity_alerts")

    @property
    @pulumi.getter(name="processGroupId")
    def process_group_id(self) -> pulumi.Output[str]:
        """
        The scope of this settings
        """
        return pulumi.get(self, "process_group_id")

