# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['KubernetesSpmArgs', 'KubernetesSpm']

@pulumi.input_type
class KubernetesSpmArgs:
    def __init__(__self__, *,
                 configuration_dataset_pipeline_enabled: pulumi.Input[bool],
                 scope: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a KubernetesSpm resource.
        :param pulumi.Input[bool] configuration_dataset_pipeline_enabled: Follow the [installation instructions](https://dt-url.net/4x23ut5) to deploy the Security Posture Management components.
        :param pulumi.Input[str] scope: The scope of this setting (KUBERNETES_CLUSTER). Omit this property if you want to cover the whole environment.
        """
        pulumi.set(__self__, "configuration_dataset_pipeline_enabled", configuration_dataset_pipeline_enabled)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)

    @property
    @pulumi.getter(name="configurationDatasetPipelineEnabled")
    def configuration_dataset_pipeline_enabled(self) -> pulumi.Input[bool]:
        """
        Follow the [installation instructions](https://dt-url.net/4x23ut5) to deploy the Security Posture Management components.
        """
        return pulumi.get(self, "configuration_dataset_pipeline_enabled")

    @configuration_dataset_pipeline_enabled.setter
    def configuration_dataset_pipeline_enabled(self, value: pulumi.Input[bool]):
        pulumi.set(self, "configuration_dataset_pipeline_enabled", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this setting (KUBERNETES_CLUSTER). Omit this property if you want to cover the whole environment.
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scope", value)


@pulumi.input_type
class _KubernetesSpmState:
    def __init__(__self__, *,
                 configuration_dataset_pipeline_enabled: Optional[pulumi.Input[bool]] = None,
                 scope: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering KubernetesSpm resources.
        :param pulumi.Input[bool] configuration_dataset_pipeline_enabled: Follow the [installation instructions](https://dt-url.net/4x23ut5) to deploy the Security Posture Management components.
        :param pulumi.Input[str] scope: The scope of this setting (KUBERNETES_CLUSTER). Omit this property if you want to cover the whole environment.
        """
        if configuration_dataset_pipeline_enabled is not None:
            pulumi.set(__self__, "configuration_dataset_pipeline_enabled", configuration_dataset_pipeline_enabled)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)

    @property
    @pulumi.getter(name="configurationDatasetPipelineEnabled")
    def configuration_dataset_pipeline_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Follow the [installation instructions](https://dt-url.net/4x23ut5) to deploy the Security Posture Management components.
        """
        return pulumi.get(self, "configuration_dataset_pipeline_enabled")

    @configuration_dataset_pipeline_enabled.setter
    def configuration_dataset_pipeline_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "configuration_dataset_pipeline_enabled", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this setting (KUBERNETES_CLUSTER). Omit this property if you want to cover the whole environment.
        """
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scope", value)


class KubernetesSpm(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 configuration_dataset_pipeline_enabled: Optional[pulumi.Input[bool]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a KubernetesSpm resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] configuration_dataset_pipeline_enabled: Follow the [installation instructions](https://dt-url.net/4x23ut5) to deploy the Security Posture Management components.
        :param pulumi.Input[str] scope: The scope of this setting (KUBERNETES_CLUSTER). Omit this property if you want to cover the whole environment.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: KubernetesSpmArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a KubernetesSpm resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param KubernetesSpmArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(KubernetesSpmArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 configuration_dataset_pipeline_enabled: Optional[pulumi.Input[bool]] = None,
                 scope: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = KubernetesSpmArgs.__new__(KubernetesSpmArgs)

            if configuration_dataset_pipeline_enabled is None and not opts.urn:
                raise TypeError("Missing required property 'configuration_dataset_pipeline_enabled'")
            __props__.__dict__["configuration_dataset_pipeline_enabled"] = configuration_dataset_pipeline_enabled
            __props__.__dict__["scope"] = scope
        super(KubernetesSpm, __self__).__init__(
            'dynatrace:index/kubernetesSpm:KubernetesSpm',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            configuration_dataset_pipeline_enabled: Optional[pulumi.Input[bool]] = None,
            scope: Optional[pulumi.Input[str]] = None) -> 'KubernetesSpm':
        """
        Get an existing KubernetesSpm resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] configuration_dataset_pipeline_enabled: Follow the [installation instructions](https://dt-url.net/4x23ut5) to deploy the Security Posture Management components.
        :param pulumi.Input[str] scope: The scope of this setting (KUBERNETES_CLUSTER). Omit this property if you want to cover the whole environment.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _KubernetesSpmState.__new__(_KubernetesSpmState)

        __props__.__dict__["configuration_dataset_pipeline_enabled"] = configuration_dataset_pipeline_enabled
        __props__.__dict__["scope"] = scope
        return KubernetesSpm(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configurationDatasetPipelineEnabled")
    def configuration_dataset_pipeline_enabled(self) -> pulumi.Output[bool]:
        """
        Follow the [installation instructions](https://dt-url.net/4x23ut5) to deploy the Security Posture Management components.
        """
        return pulumi.get(self, "configuration_dataset_pipeline_enabled")

    @property
    @pulumi.getter
    def scope(self) -> pulumi.Output[Optional[str]]:
        """
        The scope of this setting (KUBERNETES_CLUSTER). Omit this property if you want to cover the whole environment.
        """
        return pulumi.get(self, "scope")

