# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['OpenpipelineSecurityEventsArgs', 'OpenpipelineSecurityEvents']

@pulumi.input_type
class OpenpipelineSecurityEventsArgs:
    def __init__(__self__, *,
                 endpoints: Optional[pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs']] = None,
                 pipelines: Optional[pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs']] = None,
                 routing: Optional[pulumi.Input['OpenpipelineSecurityEventsRoutingArgs']] = None):
        """
        The set of arguments for constructing a OpenpipelineSecurityEvents resource.
        :param pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs'] endpoints: List of all ingest sources of the configuration
        :param pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs'] pipelines: List of all pipelines of the configuration
        :param pulumi.Input['OpenpipelineSecurityEventsRoutingArgs'] routing: Dynamic routing definition
        """
        if endpoints is not None:
            pulumi.set(__self__, "endpoints", endpoints)
        if pipelines is not None:
            pulumi.set(__self__, "pipelines", pipelines)
        if routing is not None:
            pulumi.set(__self__, "routing", routing)

    @property
    @pulumi.getter
    def endpoints(self) -> Optional[pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs']]:
        """
        List of all ingest sources of the configuration
        """
        return pulumi.get(self, "endpoints")

    @endpoints.setter
    def endpoints(self, value: Optional[pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs']]):
        pulumi.set(self, "endpoints", value)

    @property
    @pulumi.getter
    def pipelines(self) -> Optional[pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs']]:
        """
        List of all pipelines of the configuration
        """
        return pulumi.get(self, "pipelines")

    @pipelines.setter
    def pipelines(self, value: Optional[pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs']]):
        pulumi.set(self, "pipelines", value)

    @property
    @pulumi.getter
    def routing(self) -> Optional[pulumi.Input['OpenpipelineSecurityEventsRoutingArgs']]:
        """
        Dynamic routing definition
        """
        return pulumi.get(self, "routing")

    @routing.setter
    def routing(self, value: Optional[pulumi.Input['OpenpipelineSecurityEventsRoutingArgs']]):
        pulumi.set(self, "routing", value)


@pulumi.input_type
class _OpenpipelineSecurityEventsState:
    def __init__(__self__, *,
                 endpoints: Optional[pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs']] = None,
                 pipelines: Optional[pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs']] = None,
                 routing: Optional[pulumi.Input['OpenpipelineSecurityEventsRoutingArgs']] = None):
        """
        Input properties used for looking up and filtering OpenpipelineSecurityEvents resources.
        :param pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs'] endpoints: List of all ingest sources of the configuration
        :param pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs'] pipelines: List of all pipelines of the configuration
        :param pulumi.Input['OpenpipelineSecurityEventsRoutingArgs'] routing: Dynamic routing definition
        """
        if endpoints is not None:
            pulumi.set(__self__, "endpoints", endpoints)
        if pipelines is not None:
            pulumi.set(__self__, "pipelines", pipelines)
        if routing is not None:
            pulumi.set(__self__, "routing", routing)

    @property
    @pulumi.getter
    def endpoints(self) -> Optional[pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs']]:
        """
        List of all ingest sources of the configuration
        """
        return pulumi.get(self, "endpoints")

    @endpoints.setter
    def endpoints(self, value: Optional[pulumi.Input['OpenpipelineSecurityEventsEndpointsArgs']]):
        pulumi.set(self, "endpoints", value)

    @property
    @pulumi.getter
    def pipelines(self) -> Optional[pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs']]:
        """
        List of all pipelines of the configuration
        """
        return pulumi.get(self, "pipelines")

    @pipelines.setter
    def pipelines(self, value: Optional[pulumi.Input['OpenpipelineSecurityEventsPipelinesArgs']]):
        pulumi.set(self, "pipelines", value)

    @property
    @pulumi.getter
    def routing(self) -> Optional[pulumi.Input['OpenpipelineSecurityEventsRoutingArgs']]:
        """
        Dynamic routing definition
        """
        return pulumi.get(self, "routing")

    @routing.setter
    def routing(self, value: Optional[pulumi.Input['OpenpipelineSecurityEventsRoutingArgs']]):
        pulumi.set(self, "routing", value)


class OpenpipelineSecurityEvents(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 endpoints: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsEndpointsArgs', 'OpenpipelineSecurityEventsEndpointsArgsDict']]] = None,
                 pipelines: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsPipelinesArgs', 'OpenpipelineSecurityEventsPipelinesArgsDict']]] = None,
                 routing: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsRoutingArgs', 'OpenpipelineSecurityEventsRoutingArgsDict']]] = None,
                 __props__=None):
        """
        Create a OpenpipelineSecurityEvents resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['OpenpipelineSecurityEventsEndpointsArgs', 'OpenpipelineSecurityEventsEndpointsArgsDict']] endpoints: List of all ingest sources of the configuration
        :param pulumi.Input[Union['OpenpipelineSecurityEventsPipelinesArgs', 'OpenpipelineSecurityEventsPipelinesArgsDict']] pipelines: List of all pipelines of the configuration
        :param pulumi.Input[Union['OpenpipelineSecurityEventsRoutingArgs', 'OpenpipelineSecurityEventsRoutingArgsDict']] routing: Dynamic routing definition
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[OpenpipelineSecurityEventsArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a OpenpipelineSecurityEvents resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param OpenpipelineSecurityEventsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OpenpipelineSecurityEventsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 endpoints: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsEndpointsArgs', 'OpenpipelineSecurityEventsEndpointsArgsDict']]] = None,
                 pipelines: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsPipelinesArgs', 'OpenpipelineSecurityEventsPipelinesArgsDict']]] = None,
                 routing: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsRoutingArgs', 'OpenpipelineSecurityEventsRoutingArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OpenpipelineSecurityEventsArgs.__new__(OpenpipelineSecurityEventsArgs)

            __props__.__dict__["endpoints"] = endpoints
            __props__.__dict__["pipelines"] = pipelines
            __props__.__dict__["routing"] = routing
        super(OpenpipelineSecurityEvents, __self__).__init__(
            'dynatrace:index/openpipelineSecurityEvents:OpenpipelineSecurityEvents',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            endpoints: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsEndpointsArgs', 'OpenpipelineSecurityEventsEndpointsArgsDict']]] = None,
            pipelines: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsPipelinesArgs', 'OpenpipelineSecurityEventsPipelinesArgsDict']]] = None,
            routing: Optional[pulumi.Input[Union['OpenpipelineSecurityEventsRoutingArgs', 'OpenpipelineSecurityEventsRoutingArgsDict']]] = None) -> 'OpenpipelineSecurityEvents':
        """
        Get an existing OpenpipelineSecurityEvents resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['OpenpipelineSecurityEventsEndpointsArgs', 'OpenpipelineSecurityEventsEndpointsArgsDict']] endpoints: List of all ingest sources of the configuration
        :param pulumi.Input[Union['OpenpipelineSecurityEventsPipelinesArgs', 'OpenpipelineSecurityEventsPipelinesArgsDict']] pipelines: List of all pipelines of the configuration
        :param pulumi.Input[Union['OpenpipelineSecurityEventsRoutingArgs', 'OpenpipelineSecurityEventsRoutingArgsDict']] routing: Dynamic routing definition
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OpenpipelineSecurityEventsState.__new__(_OpenpipelineSecurityEventsState)

        __props__.__dict__["endpoints"] = endpoints
        __props__.__dict__["pipelines"] = pipelines
        __props__.__dict__["routing"] = routing
        return OpenpipelineSecurityEvents(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def endpoints(self) -> pulumi.Output[Optional['outputs.OpenpipelineSecurityEventsEndpoints']]:
        """
        List of all ingest sources of the configuration
        """
        return pulumi.get(self, "endpoints")

    @property
    @pulumi.getter
    def pipelines(self) -> pulumi.Output[Optional['outputs.OpenpipelineSecurityEventsPipelines']]:
        """
        List of all pipelines of the configuration
        """
        return pulumi.get(self, "pipelines")

    @property
    @pulumi.getter
    def routing(self) -> pulumi.Output[Optional['outputs.OpenpipelineSecurityEventsRouting']]:
        """
        Dynamic routing definition
        """
        return pulumi.get(self, "routing")

