# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['WebAppJavascriptUpdatesArgs', 'WebAppJavascriptUpdates']

@pulumi.input_type
class WebAppJavascriptUpdatesArgs:
    def __init__(__self__, *,
                 javascript_version: pulumi.Input[str],
                 application_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a WebAppJavascriptUpdates resource.
        :param pulumi.Input[str] javascript_version: Possible Values: `CUSTOM`, `LATEST_IE7_10_SUPPORTED`, `LATEST_STABLE`, `PREVIOUS_STABLE`
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        pulumi.set(__self__, "javascript_version", javascript_version)
        if application_id is not None:
            pulumi.set(__self__, "application_id", application_id)

    @property
    @pulumi.getter(name="javascriptVersion")
    def javascript_version(self) -> pulumi.Input[str]:
        """
        Possible Values: `CUSTOM`, `LATEST_IE7_10_SUPPORTED`, `LATEST_STABLE`, `PREVIOUS_STABLE`
        """
        return pulumi.get(self, "javascript_version")

    @javascript_version.setter
    def javascript_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "javascript_version", value)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "application_id", value)


@pulumi.input_type
class _WebAppJavascriptUpdatesState:
    def __init__(__self__, *,
                 application_id: Optional[pulumi.Input[str]] = None,
                 javascript_version: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering WebAppJavascriptUpdates resources.
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        :param pulumi.Input[str] javascript_version: Possible Values: `CUSTOM`, `LATEST_IE7_10_SUPPORTED`, `LATEST_STABLE`, `PREVIOUS_STABLE`
        """
        if application_id is not None:
            pulumi.set(__self__, "application_id", application_id)
        if javascript_version is not None:
            pulumi.set(__self__, "javascript_version", javascript_version)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> Optional[pulumi.Input[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "application_id", value)

    @property
    @pulumi.getter(name="javascriptVersion")
    def javascript_version(self) -> Optional[pulumi.Input[str]]:
        """
        Possible Values: `CUSTOM`, `LATEST_IE7_10_SUPPORTED`, `LATEST_STABLE`, `PREVIOUS_STABLE`
        """
        return pulumi.get(self, "javascript_version")

    @javascript_version.setter
    def javascript_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "javascript_version", value)


class WebAppJavascriptUpdates(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[str]] = None,
                 javascript_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a WebAppJavascriptUpdates resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        :param pulumi.Input[str] javascript_version: Possible Values: `CUSTOM`, `LATEST_IE7_10_SUPPORTED`, `LATEST_STABLE`, `PREVIOUS_STABLE`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WebAppJavascriptUpdatesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a WebAppJavascriptUpdates resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param WebAppJavascriptUpdatesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WebAppJavascriptUpdatesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[str]] = None,
                 javascript_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WebAppJavascriptUpdatesArgs.__new__(WebAppJavascriptUpdatesArgs)

            __props__.__dict__["application_id"] = application_id
            if javascript_version is None and not opts.urn:
                raise TypeError("Missing required property 'javascript_version'")
            __props__.__dict__["javascript_version"] = javascript_version
        super(WebAppJavascriptUpdates, __self__).__init__(
            'dynatrace:index/webAppJavascriptUpdates:WebAppJavascriptUpdates',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            application_id: Optional[pulumi.Input[str]] = None,
            javascript_version: Optional[pulumi.Input[str]] = None) -> 'WebAppJavascriptUpdates':
        """
        Get an existing WebAppJavascriptUpdates resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] application_id: The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        :param pulumi.Input[str] javascript_version: Possible Values: `CUSTOM`, `LATEST_IE7_10_SUPPORTED`, `LATEST_STABLE`, `PREVIOUS_STABLE`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _WebAppJavascriptUpdatesState.__new__(_WebAppJavascriptUpdatesState)

        __props__.__dict__["application_id"] = application_id
        __props__.__dict__["javascript_version"] = javascript_version
        return WebAppJavascriptUpdates(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> pulumi.Output[Optional[str]]:
        """
        The scope of this settings. If the settings should cover the whole environment, just don't specify any scope.
        """
        return pulumi.get(self, "application_id")

    @property
    @pulumi.getter(name="javascriptVersion")
    def javascript_version(self) -> pulumi.Output[str]:
        """
        Possible Values: `CUSTOM`, `LATEST_IE7_10_SUPPORTED`, `LATEST_STABLE`, `PREVIOUS_STABLE`
        """
        return pulumi.get(self, "javascript_version")

